/*
   Erik Eriksen
   Ch09_Ex07.cpp
   4-6-05
   
Output:
-------
Enter last name of candidate 1: Johnson
Enter number of votes recieved for candidate 1: 5000
Enter last name of candidate 2: Miller
Enter number of votes recieved for candidate 2: 4000
Enter last name of candidate 3: Duffy
Enter number of votes recieved for candidate 3: 6000
Enter last name of candidate 4: Robinson
Enter number of votes recieved for candidate 4: 2500
Enter last name of candidate 5: Ashtony
Enter number of votes recieved for candidate 5: 1800


  Name          Votes Receieved         % of Total
  ----          ---------------         ----------
 Johnson            5000                   25.91%
  Miller            4000                   20.73%
   Duffy            6000                   31.09%
Robinson            2500                   12.95%
 Ashtony            1800                    9.33%


Total Votes: 19300
     Winner: Duffy

Press any key to continue . . .
*/

#include <iostream>
#include <cstring>
#include <iomanip>

using namespace std;

int sum_Votes(int votes[], int n_of_c);
int win_index(int votes[], int n_of_c);
void displayOutput(string can[], int votes[], int t_votes, int winner); 

int main()
{
  string candidate[5];
  int votes[5], tot_votes, win, i;
  
  for (i = 0; i < 5; i++)
  {
    cout << "Enter last name of candidate " << (i + 1) << ": ";
    cin >> candidate[i];
    
    cout << "Enter number of votes recieved for candidate " << (i + 1) << ": ";
    cin >> votes[i];
  }
  
  tot_votes = sum_Votes(votes, 5);
  win = win_index(votes, 5);  

  displayOutput(candidate, votes, tot_votes, win);
  
  
  system("pause");
  return 0;
  
}

int sum_Votes(int votes[], int n_of_c)
{
  int i, total = 0;
  
  for (i = 0; i < n_of_c; i++)
    total += votes[i];
    
  return total;
}

int win_index(int votes[], int n_of_c)
{
  int i, currentHigh, comparer, win;
  
  currentHigh = votes[0];
  
  for (i = 0; i < n_of_c; i++)
  {
    comparer = votes[i];
    if (comparer > currentHigh)
    {  
      currentHigh = comparer;
      win = i;
    }
  }
  
  return win;
}

void displayOutput(string can[], int votes[], int t_votes, int winner)
{
  int j;
  float per_of_votes;
  
  cout << showpoint << fixed << setprecision(2);
  
  cout << "\n\n  Name\t\tVotes Receieved\t\t% of Total\n";
  cout << "  ----\t\t---------------\t\t----------\n";   
  
  for (j = 0; j < 5; j++)
  {
    per_of_votes = (static_cast<float>(votes[j])/t_votes) * 100;
    cout << setw(8) << can[j] << setw(16) << votes[j] << setw(24) << per_of_votes << "%\n";
  }
  
  cout << "\n\nTotal Votes: " << t_votes << "\n";
  cout << "     Winner: " << can[winner] << "\n\n";
}