/*
  Erik Eriksen
  Chapter 9, Exercise 10
  5-11-05
  Ch09_Ex10.cpp

OUTPUT:
-------
Average High: 58.5
 Average Low: 44.9
  High Index: 6
   Low Index: 0

Press any key to continue . . .
*/

#include <iostream>
#include <iomanip>

using namespace std;

const int noOfColumns = 12;
const int noOfRows = 2;

void getData(int tempArray[noOfColumns][noOfRows]);
float averageHigh(int tempArray[noOfColumns][noOfRows]);
float averageLow(int tempArray[noOfColumns][noOfRows]);
int indexHighTemp(int tempArray[noOfColumns][noOfRows]);
int indexLowTemp(int tempArray[noOfColumns][noOfRows]);
void displayOutput(float avgHigh, float avgLow, int highIndex, int lowIndex);

int main()
{
  int temp[noOfColumns][noOfRows];
  int highIndex, lowIndex;
  float avgHigh, avgLow;
  
  getData(temp);
  avgHigh = averageHigh(temp);
  avgLow = averageLow(temp);
  highIndex = indexHighTemp(temp);
  lowIndex = indexLowTemp(temp);
  displayOutput(avgHigh, avgLow, highIndex, lowIndex);
  
  system("pause");
  return 0;
}

void getData (int tempArray[noOfColumns][noOfRows])
{
  //Jan (high/low)
  tempArray[0][0] = 43;
  tempArray[0][1] = 34;
  
  //Feb (high/low)
  tempArray[1][0] = 45;
  tempArray[1][1] = 34;
  
  //March (high/low)
  tempArray[2][0] = 51;
  tempArray[2][1] = 38;
  
  //April (high/low)
  tempArray[3][0] = 57;
  tempArray[3][1] = 42;
  
  //may (high/low)
  tempArray[4][0] = 64;
  tempArray[4][1] = 49;
  
  //june (high/low)
  tempArray[5][0] = 70;
  tempArray[5][1] = 54;
  
  //july (high/low)
  tempArray[6][0] = 75;
  tempArray[6][1] = 58;
  
  //aug (high/low)
  tempArray[7][0] = 75;
  tempArray[7][1] = 57;
  
  //sept (high/low)
  tempArray[8][0] = 69;
  tempArray[8][1] = 52;
  
  //oct
  tempArray[9][0] = 59;
  tempArray[9][1] = 46;
  
  //nov
  tempArray[10][0] = 49;
  tempArray[10][1] = 39;
  
  //dec
  tempArray[11][0] = 45;
  tempArray[11][1] = 36;
}

float averageHigh(int tempArray[noOfColumns][noOfRows])
{
  float total = 0, avgHigh;
  
  for (int i = 0; i < noOfColumns; i++)
    total += tempArray[i][0];
    
  avgHigh = (total / noOfColumns);
  
  return avgHigh;
}

float averageLow(int tempArray[noOfColumns][noOfRows])
{
  float total = 0, avgLow;
  
  for (int i = 0; i < noOfColumns; i++)
    total += tempArray[i][1];
    
  avgLow = (total / noOfColumns);
  
  return avgLow;
}

int indexHighTemp(int tempArray[noOfColumns][noOfRows])
{
  int highIndex, currentIndex;
  highIndex = 0;
  
  for (currentIndex = 0; currentIndex < noOfColumns; currentIndex++)
  {
    if (tempArray[currentIndex][0] > tempArray[highIndex][0])
      highIndex = currentIndex;
  }
  
  return highIndex;
}

int indexLowTemp(int tempArray[noOfColumns][noOfRows])
{
  int lowIndex, currentIndex;
  lowIndex = 0;
  
  for (currentIndex = 0; currentIndex < noOfColumns; currentIndex++)
  {
    if (tempArray[currentIndex][1] < tempArray[lowIndex][1])
      lowIndex = currentIndex;
  }
  
  return lowIndex;
}

void displayOutput(float avgHigh, float avgLow, int highIndex, int lowIndex)
{
  cout << setprecision(1) << fixed;
  cout << "Average High: " << avgHigh << endl;
  cout << " Average Low: " << avgLow << endl;
  cout << "  High Index: " << highIndex << endl;
  cout << "   Low Index: " << lowIndex << endl << endl;
}
  
       