/*
  Erik Eriksen
  5-14-05
  Chapter 10: Exercise 11
  ch10_ex011.cpp

Output:
-------

I hate this program!!!!
*/

#include <iostream>
#include <vector>

using namespace std;

int binarySearch(vector<string> list, string searchItem);
void selectionSort(vector<string> list);

int main()
{
  string input;
  vector<string> list;
  bool loop = true;
  int foundIndex = 0;
  
  list.push_back("John");
  list.push_back("Bill");
  list.push_back("Dan");
  list.push_back("Minnie");
  list.push_back("Lisa");
  list.push_back("Jack");
  list.push_back("Susan");
  list.push_back("Pluto");
    
  selectionSort(list);
  
  for (unsigned int i = 0; i < list.size(); i++)
    cout << "list[" << i << "] = " << list[i] << endl;
  
  do
  {
    cout << "Enter first name (Enter zzz to end input): ";
    cin >> input;
    
    if (input != "zzz")
    {
      foundIndex = binarySearch(list, input);
      if (foundIndex == -1)
        cout << "Search Item not found!\n\n";
      else
        cout << "Item found at index: " << foundIndex << endl << endl;
    }  
  } while (input != "zzz");
  
  system("pause");
  return 0;
}

int binarySearch(vector<string> list, string searchItem)
{
  int first = 0;
  int last = list.size() - 1;
  int mid;
  
  bool found = false;
  mid = (first + last) / 2;
  while (first >= last && !found)
  {
    
    if (list[mid] == searchItem)
      found = true;
    //else 
     // if (list[mid] > searchItem)
      //  last = mid - 1;
      else
        mid++;
  }
  
  if (found)
    return mid;
  else 
    return -1;
}

void selectionSort(vector<string> list)
{
  int index, smallestIndex, minIndex;
  string temp;
  
  for (index = 0; index < list.size() - 1; index++)
  {
    smallestIndex = index;
    
    for (minIndex = index + 1; minIndex < list.size(); minIndex++)
      if (list[minIndex] < list[smallestIndex])
        smallestIndex = minIndex;
      
    temp = list[smallestIndex];
    list[smallestIndex] = list[index];
    list[index] = temp;
  }
}