/*
  Erik Eriksen
  Ch08_Ex01.cpp
  3-2-05
  
Output:
-------

How many triangles to calculate? 5
Enter angle 1: 60
Enter angle 2: 60
Enter angle 3: 60
Equilateral

Enter angle 1: 45
Enter angle 2: 90
Enter angle 3: 45
Isosceles

Enter angle 1: 30
Enter angle 2: 60
Enter angle 3: 90
Scalene

Enter angle 1: 40
Enter angle 2: 70
Enter angle 3: 80
No Triangle

Enter angle 1: 20
Enter angle 2: 30
Enter angle 3: 140
No Triangle
  
*/

#include <iostream>

using namespace std;
enum triangleType {scalene, isosceles, equilateral, noTriangle};

int triangleShape(int a, int b, int c);

int main()
{
  int angle1, angle2, angle3, triType, i, numOfTriangles;
  
  cout << "How many triangles to calculate? ";
  cin >> numOfTriangles;
  
  for (i = 0; i < numOfTriangles; i++)
  {
    cout << "Enter angle 1: ";
    cin >> angle1;
  
    cout << "Enter angle 2: ";
    cin >> angle2;
  
    cout << "Enter angle 3: ";
    cin >> angle3;
    
    triType = triangleShape(angle1, angle2, angle3);
  
    switch (triType)
    {
      case scalene:
        cout << "Scalene\n\n";
        break;
    
      case isosceles:
        cout << "Isosceles\n\n";
        break;
    
      case equilateral:
        cout << "Equilateral\n\n";
        break;
    
      case noTriangle:
        cout << "No triangle\n\n";
        break;
      default:
        cout << "ERROR!\n\n";
        break;
    }
  }
  
  system("pause");
  return 0;
}

int triangleShape(int a, int b, int c)
{
  if ((a == b) && (a == c) && (b == c))
    return equilateral;
  else if ((a == b) || (a == c) || (b == c))
    return isosceles;
  else if (a + b + c != 180)
    return noTriangle;
  else if ((a + b < c) || (b + c < a) || (a + c < b))
    return noTriangle;
  else if ((a != b) && (a != c) && (b != c))
    return scalene;
  else 
    return -1;
}

  