/*
  Erik Eriksen
  5-14-05
  Chapter 10: Exercise 8
  ch10_ex08.cpp

Output:
-------
Enter first name (Enter zzz to end input): Dan
Item found at index: 2

Enter first name (Enter zzz to end input): James
Search Item not found!

Enter first name (Enter zzz to end input): zzz
Press any key to continue . . .
*/

#include <iostream>
#include <vector>

using namespace std;

int seqSearch(vector<string> list, string searchItem);

int main()
{
  string input;
  vector<string> list;
  bool loop = true;
  int foundIndex = 0;
  
  list.push_back("John");
  list.push_back("Bill");
  list.push_back("Dan");
  list.push_back("Minnie");
  list.push_back("Lisa");
  list.push_back("Jack");
  list.push_back("Susan");
  list.push_back("Pluto");
    
  do
  {
    cout << "Enter first name (Enter zzz to end input): ";
    cin >> input;
    
    if (input != "zzz")
    {
      foundIndex = seqSearch(list, input);
      if (foundIndex == -1)
        cout << "Search Item not found!\n\n";
      else
        cout << "Item found at index: " << foundIndex << endl << endl;
    }  
  } while (input != "zzz");
  
  system("pause");
  return 0;
}

int seqSearch(vector<string> list, string searchItem)
{
  int foundIndex;
  unsigned int loc;
  bool found = false;;
  
  for (loc = 0; loc < list.size(); loc++)
    if (list[loc] == searchItem)
    {
      found = true;
      foundIndex = loc;
    }
    
  if (found == true)
    return foundIndex;
  else
    return -1;
    
}