/*
   Erik Eriksen
   5-11-05
   clockType project
   
Output:
-------
Line 2: myClock: 05:04:30
Line 5: yourClock: 2009315348:4013416:4013320
Line 9: After setting yourClock: 05:45:16
Line 15: The two times are not equal.
Line 16: Enter the hours, minutes, and seconds: 5 23 59

Line 20: New myClock: 05:23:59
Line 24: After incrementing myClock by one second, myClock: 05:24:00
Line 28: hours = 5, minutes = 24, seconds = 0
Press any key to continue . . .

*/

#include <iostream>
#include "clocktype.h"

using namespace std;

int main()
{
  clockType myClock;
  clockType yourClock;
  
  int hours;
  int minutes;
  int seconds;
  
  //set the time of myclock
  myClock.setTime(5, 4, 30);
  
  cout << "Line 2: myClock: ";
  myClock.printTime(); // print the time of myclock
  cout << endl;
  
  cout << "Line 5: yourClock: ";
  yourClock.printTime(); // print the time of yourclock
  cout << endl;
  
  //set the time of your clock
  yourClock.setTime(5, 45, 16);
  
  cout << "Line 9: After setting yourClock: ";
  yourClock.printTime();
  cout << endl;
  
  //compare myclock and yourclock
  if (myClock.equalTime(yourClock))
    cout << "Line 13: Both times are equal." << endl;
  else
    cout << "Line 15: The two times are not equal." << endl;
    
  cout << "Line 16: Enter the hours, minutes, and seconds: ";
  cin >> hours >> minutes >> seconds;
  cout << endl;
  
  //set the time of myclock using the vlaue of the
  //variables hours, minutes and seconds
  myClock.setTime(hours, minutes, seconds);
  
  cout << "Line 20: New myClock: ";
  myClock.printTime();
  cout << endl;
  
  //increment the time of my clock by one second
  myClock.incrementSeconds();
  
  cout << "Line 24: After incrementing myClock by one second, myClock: ";
  myClock.printTime();
  cout << endl;
  
  //retrieve the hours, minutes , and seconds of the object myclock.
  myClock.getTime(hours, minutes, seconds);
  
  //output the value of hours, minutes, and seconds.
  cout << "Line 28: hours = " << hours 
       << ", minutes = " << minutes
       << ", seconds = " << seconds << endl;
       
  system("PAUSE");	
  return 0;
}