#ifndef __CDRAW_H
#define __CDRAW_H

//using namespace std;

class draw
{
	public:
		void cls(); //clears screen
		void gotoxy(int, int); //puts cursor on set spot on screen.
		void setPlayerPos(int, int); //initial setting
		void resetPlayerPos(int); //auto reset when changing areas
		void setArea(int, int); //draws background of (int area#) and sets shop locations
		void playerAtLoc(); //draws player at current location
		void movePlayer(int, int); //moves distance of x,y
		bool checkInBounds(int); //checks if in bounds of area. heading int direction.
		int checkCollision(); //checks to see if collision happened and returns int value of what happened
		int numAdventureScreens(int); //sets num of screens between towns
		
		
	private:
		int pX, pY; //player x + y
		bool wepShop, magicShop, inn, castle;
		int wepShopX, wepShopY, magicShopX, magicShopY, innX, innY, castleX, castleY;
		int areaExitX, areaExitY, areaEntX, areaEntY;
		
};

#endif
